#! /usr/bin/env bash

# SPDX-FileCopyrightText: 2024 eclipse foundation
# SPDX-License-Identifier: EPL-2.0

# * Generate <instance>/target/config.json file
# * Call gen-mvn-settings.sh script

# set -o errexit
# set -o nounset
# set -o pipefail

: "${GRAC_DEBUG:=""}"
[[ -n "${GRAC_DEBUG}" ]] && [[ "${GRAC_DEBUG}" == "true" ]] && set -x

DRY_MESSAGE=""
: "${GRAC_DRY:=""}"
[[ -n "${GRAC_DRY}" ]] && [[ "${GRAC_DRY}" == "true" ]] && DRY_MESSAGE="Dry mode (ON)"

IFS=$'\n\t'
SCRIPT_FOLDER="$(dirname "$(readlink -f "${BASH_SOURCE[0]}")")"

# shellcheck disable=SC1091
. "${SCRIPT_FOLDER}/log.sh"

# shellcheck disable=SC1091
 . "${SCRIPT_FOLDER}/gitlab_context.sh"

log info  "############################ START config ${DRY_MESSAGE} ############################"

# shellcheck disable=SC1091
. "${SCRIPT_FOLDER}/k8s-context.sh" 

instance="${1:-}"

start=$(date +"%s")

if [ -z "${instance}" ]; then
  log error "You must provide an 'instance' name argument"
  exit 1
fi

if [ ! -d "${instance}/${CURRENT_CLUSTER_CONTEXT}" ]; then
  log warn "No 'instance' found at '${instance}/${CURRENT_CLUSTER_CONTEXT}' \n" \
            "Create a new instance with : './grac.sh create ${instance##*/}'" 
  exit 
fi

target="${instance}/${CURRENT_CLUSTER_CONTEXT}/target"

# create all directories
rm -rf "${target:?}/*" 2> /dev/null || true
mkdir -p "${target}/k8s/.secrets"

GRAC_VERSION="$(grep -oP '(?<="version": ")[^"]*' ${SCRIPT_FOLDER}/../bpkg.json)"

JSONNET_PARAM=(
  "--ext-str" "cluster=${CURRENT_CLUSTER_CONTEXT}" \
  "--ext-str" "currentDate=$(date "+%F-%T")" \
  "--ext-str" "gracVersion=${GRAC_VERSION}"
)

load_pĥase() {
  local phase_number="${1:-}"

  log info "########## Phase ${phase_number} ##########"
  if [[ -f "${instance}/grac-phase${phase_number}.libsonnet" ]]; then
    # note the -J as we will need to import config.json as generated by phase 1
    jsonnet -m "${target}" -J "${instance}/${CURRENT_CLUSTER_CONTEXT}/target" "${instance}/grac-phase-{phase_number}.libsonnet" "${JSONNET_PARAM[@]}"
  else 
    # otherwise, take the one from the templates.
    # note the -J as we will need to import config.json as generated by phase 1
    jsonnet -m "${target}" -J "${instance}/${CURRENT_CLUSTER_CONTEXT}/target" "${SCRIPT_FOLDER}/../templates/grac-phase-${phase_number}.libsonnet" "${JSONNET_PARAM[@]}"
  fi
}

load_external() {
  local configurationFile="${1:-}"
  if [[ -f "${configurationFile}" ]]; then
    configuration=$(basename -- "$configurationFile")
    configuration="${configuration%.*}"
    type="${configuration##*-}"
    JSONNET_PARAM+=("--ext-code-file" "${type}=${configurationFile}")
    log info "Load ${type} configuration: ${configurationFile}"
  fi
}
conf_dir=${instance}/../../conf

log info "########## Phase 1 ##########"

# load external config
load_external "${conf_dir}/config.libsonnet"

# load external ressource pack
for packConfigFile in "${conf_dir}"/packs*.libsonnet
do
  load_external "${packConfigFile}"
done

log info "jsonnet: ${target} ${instance}/${CURRENT_CLUSTER_CONTEXT}/grac.jsonnet ${JSONNET_PARAM[@]}"

# Phase 1: default value from default config + project config
jsonnet -m "${target}" "${instance}/${CURRENT_CLUSTER_CONTEXT}/grac.jsonnet" "${JSONNET_PARAM[@]}"

load_pĥase 1
load_pĥase 2

end=$(date +"%s")
runtime=$(echo "$end - $start" | bc -l)
log info  "############################ END config in ${runtime}s ############################"


